/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = {
	"code": "byte zahl = 126;\nzahl = zahl + 1;\nzahl = zahl + 1;\nzahl = 130;\nzahl = -128;\nzahl = zahl - 1;\nzahl = 3;\nzahl = zahl + 256;\nzahl = 64;\nzahl = 4 * zahl;",
	"steps": [
		{
			"line": -1,
			"vars": {
				"instances": [],
				"vars": [],
				"scopes": []
			},
			"task": "<p>Auch <code>byte</code> ist ein Datentyp für Ganzzahlen. Der mögliche Wertebereich ist allerdings geringer als bei <code>int</code>. Bei <code>byte</code> ist der kleinste mögliche Wert <code>-128</code> und der größte mögliche Wert <code>127</code>. Was bei Wertezuweisungen passiert, wenn die zugewiesene Zahl größer oder kleiner ist, zeige ich dir am besten anhand konkreter Beispiele.</p><p>Beachte: Eigentlich müsste ich vor jede konstante Zahl <code>(byte)</code> schreiben, damit Java die Zahl nicht als <code>int</code>-Wert, sondern als <code>byte</code>-Wert interpretiert. Das habe ich aber absichtlich weggelassen, weil es erst einmal nur verwirren könnte und ich dir nur den Unterschied zwischen den Datentypen nahebringen möchte.</p><p>Starte nun mit der Ausführung dieses Algorithmus, indem du die erste Anweisung auswählst.</p>"
		},
		{
			"task": "<code>126</code> ist im möglichen Wertebereich (also kleinergleich <code>127</code>). Führe diese Wertezuweisung ganz normal aus.",
			"line": 0,
			"vars": []
		},
		{
			"task": "Dieser Summenwert liegt auch gerade noch im möglichen Wertebereich (also kleinergleich <code>127</code>). Führe diese Wertezuweisung ganz normal aus.",
			"line": 1,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 126
				}
			]
		},
		{
			"task": "Der Summenwert <code>128</code> ist zu groß (also nicht kleinergleich <code>127</code>). Darum kommt es zum sogenannten <em>Überlauf</em>, es geht wieder von vorne los. Die „nächste“ Zahl nach <code>127</code> ist der kleinstmögliche Wert <code>-128</code>.",
			"line": 2,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 127
				}
			]
		},
		{
			"task": "Überlege, was diese Wertezuweisung bewirkt. Bedenke, dass es bei <code>128</code> zum Überlauf kommt, also <code>128</code> für <code>byte</code>-Variablen Dasselbe wie <code>-128</code> ist.",
			"line": 3,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": -128
				}
			]
		},
		{
			"task": "Der Wert <code>-128</code> ist ja als kleinstmöglicher Wert für <code>byte</code>-Variablen erlaubt.",
			"line": 4,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": -126
				}
			]
		},
		{
			"task": "Analog zum Überlauf bei zu großen Werten geht es es aus Sicht von <code>byte</code>-Variablen vor dem kleinsten Wert <code>-128</code> mit dem größtmöglichen Wert <code>127</code> weiter.",
			"line": 5,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": -128
				}
			]
		},
		{
			"task": "Diese Wertezuweisung ist ganz normal.",
			"line": 6,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 127
				}
			]
		},
		{
			"task": "Wenn du den Wert einer <code>byte</code>-Variablen um <code>256</code> erhöhst oder verringerst, ändert sich der Wert nicht. Warum? Schauen wir uns mal dieses Beispiel genauer an: Bei <code>128</code>, also wenn <code>125</code> der <code>256</code> hinzugefügt wurden, kommt es zum Überlauf. Insofern ist <code>3 + 256</code> gleich <code>3 + 125 + 131</code>, also <code>-127 + 131</code>. Und das ergibt <code>3</code>.",
			"line": 7,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 3
				}
			]
		},
		{
			"task": "Hier ist nichts zu beachten.",
			"line": 8,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 3
				}
			]
		},
		{
			"task": "Auch bei Multiplikation (oder Division) kann es zum Überlauf kommen. Bekommst du heraus, was hier der neue Variablenwert ist? Rechne den Produktwert zuerst normal aus und überlege dann, wie viel mehr das als der „Überlaufwert“ <code>128</code> ist, der ja bei <code>byte</code>-Variablen gleich dem kleinsten möglichen Wert <code>-128</code> ist.",
			"line": 9,
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 64
				}
			]
		},
		{
			"line": "end",
			"vars": [
				{
					"key": "zahl",
					"type": "byte",
					"value": 0
				}
			]
		}
	]
};
